//+------------------------------------------------------------------+
//|                                                     Fractals.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                                 Update by Kharko |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Gold
#property indicator_width1 1
#property indicator_width2 1
//---- input parameters

extern   int   Order = 2;
extern   int   Depth = 1;

//---- buffers
double ExtUpFractalsBuffer[];
double ExtDownFractalsBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicator buffers mapping  
    SetIndexBuffer(0,ExtUpFractalsBuffer);
    SetIndexBuffer(1,ExtDownFractalsBuffer);   
//---- drawing settings
    SetIndexStyle(0,DRAW_ARROW);
    SetIndexArrow(0,217);
    SetIndexStyle(1,DRAW_ARROW);
    SetIndexArrow(1,218);
//----
    SetIndexEmptyValue(0,0.0);
    SetIndexEmptyValue(1,0.0);
//---- name for DataWindow
    SetIndexLabel(0,"Fractal Up");
    SetIndexLabel(1,"Fractal Down");
//---- initialization done   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   
//----
   return(0);
  }
  
double   high(int middle, int i, int Depth)
{
   double result;
   int counter=0;
   if (Depth==1)
      result = High[i];
   if (Depth>1)
   {
      result = iCustom(Symbol(), Period(), "Fractals[1]", Order, Depth-1, 0, i);
      int j=i;
      while ( (counter!=MathAbs(middle-i)) && (j>0) && (j<Bars) )
      {
         if ((middle-i)>0) j--;
         else  j++;
         result = iCustom(Symbol(), Period(), "Fractals[1]", Order, Depth-1, 0, j);
         if (result!=0) counter++;
      }
   }
   return(result);
}

double   low(int middle, int i, int Depth)
{
   double result;
   int counter=0;
   if (Depth==1)
      result = Low[i];
   if (Depth>1)
   {
      result = iCustom(Symbol(), Period(), "Fractals[1]", Order, Depth-1, 1, i);
      int j=i;
      while ( (counter!=MathAbs(middle-i)) && (j>0) && (j<Bars) )
      {
         if ((middle-i)>0) j--;
         else  j++;
         result = iCustom(Symbol(), Period(), "Fractals[1]", Order, Depth-1, 1, j);
         if (result!=0) counter++;
      }
   }
   return(result);
}  
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    i,nCountedBars;
   bool   bFound;
   double dCurrent;
   nCountedBars=IndicatorCounted();
//---- last counted bar will be recounted    
   i=Bars-nCountedBars+Order+1;
//----Up and Down Fractals
   while(i>=Order+1)
   {
      //----Fractals up
      bFound=true;
      dCurrent=high(i, i, Depth);
      for (int j=1; j<=Order; j++)
      {
         if ((dCurrent<=high(i, i+j, Depth)) || (dCurrent<=high(i, i-j, Depth)))
            bFound = false;
      }
      if (bFound) ExtUpFractalsBuffer[i]=dCurrent;
                                 
      //----Fractals down
      bFound=true;
      dCurrent=low(i, i, Depth);
      for (j=1; j<=Order; j++)
      {
         if ((dCurrent>=low(i, i+j, Depth)) || (dCurrent>=low(i, i-j, Depth)) )
            bFound = false;
      }
      if (bFound) ExtDownFractalsBuffer[i]=dCurrent;
     i--;
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+